#ifndef ns_Pri_dtail_h
#define ns_Pri_dtail_h

#include <string.h>
#include "queue.h"
#include "config.h"
#include <map>

/*
 * A bounded, drop-tail queue
 */
 
 // ----  Added jz ---- This is table for Qed packets to deliver.
typedef std::map<int, Packet *> uid_pkt_tbl_t; // map from uid to packet pointer

 
class Pri_dtail : public Queue {
  public:
	Pri_dtail() { 
		q_ = new PacketQueue; 
		pq_ = q_;
		bind_bool("drop_front_", &drop_front_);
		bind_bool("summarystats_", &summarystats);
		bind_bool("queue_in_bytes_", &qib_);  // boolean: q in bytes?
		bind("mean_pktsize_", &mean_pktsize_);
		//		_RENAMED("drop-front_", "drop_front_");
	}
	
	Pri_dtail(int qsize) : Queue(qsize) {
		q_ = new PacketQueue; 
		pq_ = q_;
		drop_front_ = 1;
		summarystats = 0;
		qib_ = 0;  // boolean: q in bytes?
		mean_pktsize_ = qsize;
		limit() = qsize;
	}
	~Pri_dtail() {
		delete q_;
	}
	
//	void target_handle(NsObject* targ, Queue* hdl);
	Packet* deque();
	inline void recv(Packet* p, Handler* h) { enque(p); } ;
	inline void remove(Packet* p) { 
		q_->remove(p);
		(*pkt_map_).erase(hdr_cmn::access(p)->uid()); 
	};
	void enqueHead(Packet* p);
	bool enque_insert(Packet* p, Packet* pp);
	
	inline Packet* lookup(int n) { return (q_->lookup(n)); };
	inline Packet* head() { return (q_->head());};
	Packet* tail() { return (q_->tail());};
	inline void remove(Packet *p, Packet *pp) { 
		q_->remove(p, pp); 
		(*pkt_map_).erase(hdr_cmn::access(p)->uid());
	};
	inline void setDropFront() { drop_front_ = 1; };
	
	void enque(Packet*);
	
	bool isAdd2_Overflow(Packet *p);
public:
	PacketQueue *q_;	/* underlying FIFO queue */
	uid_pkt_tbl_t *pkt_map_;
	
protected:
	void reset();
	int command(int argc, const char*const* argv); 

	void shrink_queue();	// To shrink queue and drop excessive packets.

	int drop_front_;	/* drop-from-front (rather than from tail) */
	int summarystats;
	void print_summarystats();
	int qib_;       	/* bool: queue measured in bytes? */
	int mean_pktsize_;	/* configured mean packet size in bytes */
//    Queue * hdl_Psched_;
};

#endif
